commit bd0179f31dfb9b009cb561d336f3f1c6fbdd4ceb
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Feb 27 22:34:57 2023 +0000

    libstdc++: Fix uses_allocator_construction_args for pair<T&&, U&&> [PR108952]
    
    This implements LWG 3527 which fixes the handling of pair<T&&, U&&> in
    std::uses_allocator_construction_args.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/108952
            * include/std/memory (uses_allocator_construction_args):
            Implement LWG 3527.
            * testsuite/20_util/pair/astuple/get-2.cc: New test.
            * testsuite/20_util/scoped_allocator/108952.cc: New test.
            * testsuite/20_util/uses_allocator/lwg3527.cc: New test.
    
    (cherry picked from commit 8e342c04550466ab088c33746091ce7f3498ee44)

diff --git a/libstdc++-v3/include/std/memory b/libstdc++-v3/include/std/memory
index eea472e8600..ce54f260257 100644
--- a/libstdc++-v3/include/std/memory
+++ b/libstdc++-v3/include/std/memory
@@ -378,11 +378,14 @@ get_pointer_safety() noexcept { return pointer_safety::relaxed; }
       using _Tp1 = typename _Tp::first_type;
       using _Tp2 = typename _Tp::second_type;
 
+      // _GLIBCXX_RESOLVE_LIB_DEFECTS
+      // 3527. uses_allocator_construction_args handles rvalue pairs
+      // of rvalue references incorrectly
       return std::make_tuple(piecewise_construct,
 	  std::uses_allocator_construction_args<_Tp1>(__a,
-	    std::move(__pr).first),
+	    std::get<0>(std::move(__pr))),
 	  std::uses_allocator_construction_args<_Tp2>(__a,
-	    std::move(__pr).second));
+	    std::get<1>(std::move(__pr))));
     }
 
   template<typename _Tp, typename _Alloc, typename... _Args>
diff --git a/libstdc++-v3/testsuite/20_util/pair/astuple/get-2.cc b/libstdc++-v3/testsuite/20_util/pair/astuple/get-2.cc
new file mode 100644
index 00000000000..573d239effa
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/pair/astuple/get-2.cc
@@ -0,0 +1,68 @@
+// { dg-do compile { target c++11 } }
+
+#include <utility>
+
+template<int N, typename T, typename Pair>
+constexpr bool
+check()
+{
+  return std::is_same<decltype(std::get<N>(std::declval<Pair>())), T>::value;
+}
+
+void
+test_value_category()
+{
+  using P = std::pair<int, long>;
+  static_assert( check<0, int&, P&>(),
+		 "get<0>(pair<T1, T2>&)" );
+  static_assert( check<1, long&, P&>(),
+		 "get<1>(pair<T1, T2>&)" );
+  static_assert( check<0, int&&, P&&>(),
+		 "get<0>(pair<T1, T2>&&)" );
+  static_assert( check<1, long&&, P&&>(),
+		 "get<1>(pair<T1, T2>&&)" );
+  static_assert( check<0, const int&, const P&>(),
+		 "get<0>(const pair<T1, T2>&)" );
+  static_assert( check<1, const long&, const P&>(),
+		 "get<1>(const pair<T1, T2>&)" );
+  static_assert( check<0, const int&&, const P&&>(),
+		 "get<0>(const pair<T1, T2>&&)" );
+  static_assert( check<1, const long&&, const P&&>(),
+		 "get<1>(const pair<T1, T2>&&)" );
+
+  using PL = std::pair<int&, long&>;
+  static_assert( check<0, int&, PL&>(),
+		 "get<0>(pair<T1&, T2&>&)" );
+  static_assert( check<1, long&, PL&>(),
+		 "get<1>(pair<T1&, T2&>&)" );
+  static_assert( check<0, int&, PL&&>(),
+		 "get<0>(pair<T1&, T2&>&&)" );
+  static_assert( check<1, long&, PL&&>(),
+		 "get<1>(pair<T1&, T2&>&&)" );
+  static_assert( check<0, int&, const PL&>(),
+		 "get<0>(const pair<T1&, T2&>&)" );
+  static_assert( check<1, long&, const PL&>(),
+		 "get<1>(const pair<T1&, T2&>&)" );
+  static_assert( check<0, int&, const PL&&>(),
+		 "get<0>(const pair<T1&, T2&>&&)" );
+  static_assert( check<1, long&, const PL&&>(),
+		 "get<1>(const pair<T1&, T2&>&&)" );
+
+  using PR = std::pair<int&&, long&&>;
+  static_assert( check<0, int&, P&>(),
+		 "get<0>(pair<T1&&, T2&&>&)" );
+  static_assert( check<1, long&, P&>(),
+		 "get<1>(pair<T1&&, T2&&>&)" );
+  static_assert( check<0, int&&, PR&&>(),
+		 "get<0>(pair<T1&&, T2&&>&&)" );
+  static_assert( check<1, long&&, PR&&>(),
+		 "get<1>(pair<T1&&, T2&&>&&)" );
+  static_assert( check<0, int&, const PR&>(),
+		 "get<0>(const pair<T1&&, T2&&>&)" );
+  static_assert( check<1, long&, const PR&>(),
+		 "get<1>(const pair<T1&&, T2&&>&)" );
+  static_assert( check<0, int&&, const PR&&>(),
+		 "get<0>(const pair<T1&&, T2&&>&&)" );
+  static_assert( check<1, long&&, const PR&&>(),
+		 "get<1>(const pair<T1&&, T2&&>&&)" );
+}
diff --git a/libstdc++-v3/testsuite/20_util/scoped_allocator/108952.cc b/libstdc++-v3/testsuite/20_util/scoped_allocator/108952.cc
new file mode 100644
index 00000000000..a6b9c67498c
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/scoped_allocator/108952.cc
@@ -0,0 +1,23 @@
+// { dg-do compile { target c++11 } }
+
+#include <scoped_allocator>
+
+struct move_only
+{
+  move_only(move_only&&);
+};
+
+using P = std::pair<move_only, move_only>;
+
+void
+test_pr108952(std::pair<move_only&&, move_only&&> rvals)
+{
+  // LWG 3527. uses_allocator_construction_args handles rvalue pairs of
+  // rvalue references incorrectly.
+  // PR libstdc++/108952 Regression in uses_allocator_construction_args
+  // for pair of rvalue references
+  std::scoped_allocator_adaptor<std::allocator<P>> a;
+  auto p = a.allocate(1);
+  a.construct(p, std::move(rvals));
+  a.deallocate(p, 1);
+}
diff --git a/libstdc++-v3/testsuite/20_util/uses_allocator/lwg3527.cc b/libstdc++-v3/testsuite/20_util/uses_allocator/lwg3527.cc
new file mode 100644
index 00000000000..ae377f4b5a3
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/uses_allocator/lwg3527.cc
@@ -0,0 +1,22 @@
+// { dg-options "-std=gnu++20" }
+// { dg-do compile { target c++20 } }
+
+#include <memory>
+
+struct move_only
+{
+  move_only(move_only&&);
+};
+
+using P = std::pair<move_only, move_only>;
+
+void
+test_lwg3527(std::pair<move_only&&, move_only&&> rvals)
+{
+  // LWG 3527. uses_allocator_construction_args handles rvalue pairs of
+  // rvalue references incorrectly.
+  // PR libstdc++/108952 Regression in uses_allocator_construction_args
+  // for pair of rvalue references
+  std::allocator<move_only> a;
+  (void) std::uses_allocator_construction_args<P>(a, std::move(rvals));
+}

